      SUBROUTINE OCRP(IPEROC,ITSOC)
C     ******************************************************************
C     SETUP OUTPUT CONTROL
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
      CHARACTER*80 LINE,CTMP
      CHARACTER*18 FTYP
C     ------------------------------------------------------------------
      CHEDFM='(BINARY)'
      CDDNFM='(BINARY)'
C
      INOC=IUNIT(12)
C
C3------CHECK FOR FREE FORMAT -- READ FIRST RECORD AND DECODE FIRST
C3------WORD.
      READ(IUREAL(INOC),'(A)') LINE
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
      IF(LINE(ISTART:ISTOP).EQ.'PERIOD' .OR. LINE(ISTART:ISTOP).EQ.
     1     'HEAD' .OR. LINE(ISTART:ISTOP).EQ.'DRAWDOWN' .OR.
     2        LINE(ISTART:ISTOP).EQ.'COMPACT') GO TO 90
C
C4------IF NUMERIC OUTPUT CONTROL, FIRST WORD WILL NOT BE "PERIOD",
C4------"HEAD", "DRAWDOWN", OR "COMPACT".  DECODE THE NUMERIC VALUES
      WRITE(IOUT,2)
    2 FORMAT(1X,/1X,'OUTPUT CONTROL IS SPECIFIED EVERY TIME STEP')
C4A-----CHECK FOR FORCED FIXED FORMAT
      IF(MODINP.EQ.0) THEN
         READ(LINE,'(4I10)') IHEDFM,IDDNFM,IHEDUN,IDDNUN
      ELSE
         CTMP=' '
         CTMP(80-ISTOP+ISTART:80)=LINE(ISTART:ISTOP)
         READ(CTMP,'(I80)',ERR=2000) IHEDFM
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IDDNFM,R,IOUT,
     1            IUREAL(INOC))
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IHEDUN,R,IOUT,
     1            IUREAL(INOC))
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IDDNUN,R,IOUT,
     1            IUREAL(INOC))
      END IF
C
C4B------WRITE CONTENTS OF FIRST RECORD.
      WRITE(IOUT,3) IHEDFM,IDDNFM
    3 FORMAT(1X,'HEAD PRINT FORMAT CODE IS',I4,
     1        '    DRAWDOWN PRINT FORMAT CODE IS',I4)
      WRITE(IOUT,4) IHEDUN,IDDNUN
    4 FORMAT(1X,'HEADS WILL BE SAVED ON UNIT',I4,
     1        '    DRAWDOWNS WILL BE SAVED ON UNIT',I4)
      IPEROC=-1
      ITSOC=-1
      GO TO 1000
C
C5------ALPHABETIC OUPUT CONTROL.  WRITE MESSAGE AND SET INITIAL VALUES
C5------FOR IPEROC AND ITSOC.
   90 WRITE(IOUT,91)
   91 FORMAT(1X,/1X,'OUPUT CONTROL IS SPECIFIED ONLY AT TIME STEPS FOR',
     1    ' WHICH OUTPUT IS DESIRED')
      IPEROC=9999
      ITSOC=9999
C
C5A-----LOOK FOR "PERIOD", WHICH INDICATES THE END OF OUTPUT CONTROL
C5A-----SET UP INFORMATION.  IF FOUND, DECODE THE PERIOD NUMBER AND
C5A-----TIME STEP NUMBER FOR LATER USE>
  100 IF(LINE(ISTART:ISTOP).EQ.'PERIOD') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPEROC,R,IOUT,
     1                   IUREAL(INOC))
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
         IF(LINE(ISTART:ISTOP).NE.'STEP') GO TO 2000
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ITSOC,R,IOUT,IUREAL(INOC))
         WRITE(IOUT,3) IHEDFM,IDDNFM
         WRITE(IOUT,4) IHEDUN,IDDNUN
         GO TO 1000
C
C5B-----LOOK FOR "HEAD PRINT FORMAT" AND "HEAD SAVE FORMAT".  IF
C5B-----FOUND, SET APPROPRIATE FLAGS.
      ELSE IF(LINE(ISTART:ISTOP).EQ.'HEAD') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
         IF(LINE(ISTART:ISTOP).EQ.'PRINT') THEN
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
            IF(LINE(ISTART:ISTOP).NE.'FORMAT') GO TO 2000
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IHEDFM,R,IOUT,
     1                  IUREAL(INOC))
         ELSE IF(LINE(ISTART:ISTOP).EQ.'SAVE') THEN
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
            IF(LINE(ISTART:ISTOP).EQ.'UNIT') THEN
               CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IHEDUN,R,IOUT,
     1            IUREAL(INOC))
            ELSE IF(LINE(ISTART:ISTOP).EQ.'FORMAT') THEN
               CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,
     1                  IUREAL(INOC))
               CHEDFM=LINE(ISTART:ISTOP)
               WRITE(IOUT,103) CHEDFM
  103          FORMAT(1X,'HEADS WILL BE SAVED WITH FORMAT: ',A)
               CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,
     1                  IUREAL(INOC))
               IF(LINE(ISTART:ISTOP).EQ.'LABEL') THEN
                  LBHDSV=1
                  WRITE(IOUT,104)
  104             FORMAT(1X,'SAVED HEADS WILL BE LABELED')
               END IF
            ELSE
               GO TO 2000
            END IF
         ELSE
            GO TO 2000
         END IF
C
C5C-----LOOK FOR "DRAWDOWN PRINT FORMAT" AND "DRAWDOWN SAVE FORMAT".
C5C-----IF FOUND, SET APPROPRIATE FLAGS
      ELSE IF(LINE(ISTART:ISTOP).EQ.'DRAWDOWN') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
         IF(LINE(ISTART:ISTOP).EQ.'PRINT') THEN
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
            IF(LINE(ISTART:ISTOP).NE.'FORMAT') GO TO 2000
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IDDNFM,R,IOUT,
     1                   IUREAL(INOC))
         ELSE IF(LINE(ISTART:ISTOP).EQ.'SAVE') THEN
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
            IF(LINE(ISTART:ISTOP).EQ.'UNIT') THEN
               CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IDDNUN,R,IOUT,
     1                   IUREAL(INOC))
            ELSE IF(LINE(ISTART:ISTOP).EQ.'FORMAT') THEN
               CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,N,R,IOUT,
     1                    IUREAL(INOC))
               CDDNFM=LINE(ISTART:ISTOP)
               WRITE(IOUT,105) CDDNFM
  105          FORMAT(1X,'DRAWDOWN WILL BE SAVED WITH FORMAT: ',A)
               CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,
     1                    IUREAL(INOC))
               IF(LINE(ISTART:ISTOP).EQ.'LABEL') THEN
                  LBDDSV=1
                  WRITE(IOUT,106)
  106             FORMAT(1X,'SAVED DRAWDOWN WILL BE LABELED')
               END IF
            ELSE
               GO TO 2000
            END IF
         ELSE
            GO TO 2000
         END IF
C
C5D-----LOOK FOR "COMPACT BUDGET FILES" -- "COMPACT" IS SUFFICIENT.
C5D-----IF FOUND, SET APPROPRIATE FLAG.
      ELSE IF(LINE(ISTART:ISTOP).EQ.'COMPACT') THEN
         IBDOPT=2
         WRITE(IOUT,107)
  107    FORMAT(1X,'COMPACT CELL-BY-CELL BUDGET FILES WILL BE WRITTEN')
C
C5E-----ERROR IF UNRECOGNIZED WORD.
      ELSE
         GO TO 2000
      END IF
C
C6------FINISHED READING A RECORD.  READ NEXT RECORD, IGNORING BLANK
C6------LINES.  GO BACK AND DECODE IT.
  110 READ(IUREAL(INOC),'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 110
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,IUREAL(INOC))
      GO TO 100
C
C7------CHECK IHEDUN AND IDDNUN AND RETURN.
 1000 FTYP='DATA'
      IF(CHEDFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
      IF(IHEDUN.GT.0) THEN
         IF(FILTYP(IHEDUN).EQ.FTYP) THEN
            IF(IFNUSE(IHEDUN).LE.0) THEN
               IFNUSE(IHEDUN)=INOC
            ELSE
               WRITE(IOUT,*)
     1  'Head file already being used by another package'
               CALL RDABRT
            END IF
         ELSE IF(FILTYP(IHEDUN).EQ.' ') THEN
            IHEDUN=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to use the wrong file type for saving head'
            CALL RDABRT
         END IF
      END IF
C
      FTYP='DATA'
      IF(CDDNFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
      IF(IDDNUN.GT.0) THEN
         IF(FILTYP(IDDNUN).EQ.FTYP) THEN
            IF(IDDNUN.EQ.IHEDUN .OR. IFNUSE(IDDNUN).LE.0) THEN
               IFNUSE(IDDNUN)=INOC
            ELSE
               WRITE(IOUT,*)
     1  'Drawdown file already being used by another package'
               CALL RDABRT
            END IF
         ELSE IF(FILTYP(IDDNUN).EQ.' ') THEN
            IDDNUN=0
         ELSE
            WRITE(IOUT,*)
     1 'Attempt to use the wrong file type for saving drawdown'
            CALL RDABRT
         END IF
      END IF
C
      RETURN
C
C8------ERROR DECODING INPUT DATA.
 2000 WRITE(IOUT,2001) LINE
 2001 FORMAT(1X,/1X,'ERROR READING OUTPUT CONTROL INPUT DATA:'/1X,A80)
      CALL MFISTP
C      STOP
      END
      SUBROUTINE BASOC(KSTP,KPER,IPEROC,ITSOC,IOFLG,
     1     NTSOUT,INONE,IEND,IALPER,IALSTP)
C     ******************************************************************
C     OUTPUT CONTROLLER FOR HEAD, DRAWDOWN, AND BUDGET
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
      DIMENSION IOFLG(200,4)
      DIMENSION NTSOUT(6),INONE(6),IEND(6),IALPER(6),IALSTP(6)
C     ------------------------------------------------------------------
      CALL IVLGET('IXSEC',0,0,ITYPE,IXSEC)
      IF(ITYPE.NE.0) IXSEC=0
      INOC=IUNIT(12)
C
C2------IF IPEROC >= 0, CALL MODULE TO READ DATA USING ALPHABETIC INPUT
C2------STRUCTURE.
      IF(IPEROC.GE.0) THEN
         CALL SBASN(IOFLG,NLAY,IHDDFL,IBUDFL,ICBCFL,IPEROC,ITSOC,KPER,
     1            KSTP,IUREAL(INOC),IOUT,IBDOPT)
         GO TO 600
      END IF
C
C3------READ AND PRINT OUTPUT FLAGS AND CODE FOR DEFINING IOFLG USING
C3------THE ORIGINAL NUMERIC INPUT STRUCTURE.
      IF(MODINP.EQ.0)
     1         READ(IUREAL(INOC),'(4I10)') INCODE,IHDDFL,IBUDFL,ICBCFL
      IF(MODINP.NE.0) READ(IUREAL(INOC),*) INCODE,IHDDFL,IBUDFL,ICBCFL
      WRITE(IOUT,3) IHDDFL,IBUDFL,ICBCFL
    3 FORMAT(1X,/1X,'HEAD/DRAWDOWN PRINTOUT FLAG =',I2,
     1    5X,'TOTAL BUDGET PRINTOUT FLAG =',I2,
     2   /1X,'CELL-BY-CELL FLOW TERM FLAG =',I2)
      IF(ICBCFL.NE.0) ICBCFL=IBDOPT
C
C4------DECODE INCODE TO DETERMINE HOW TO SET FLAGS IN IOFLG.
      IF(INCODE) 100,200,300
C
C5------USE IOFLG FROM LAST TIME STEP.
  100 WRITE(IOUT,101)
  101 FORMAT(1H ,'REUSING PREVIOUS VALUES OF IOFLG')
      GO TO 600
C
C6------READ IOFLG FOR LAYER 1 AND ASSIGN SAME TO ALL LAYERS
  200 IF(MODINP.EQ.0) READ(IUREAL(INOC),'(4I10)') (IOFLG(1,M),M=1,4)
      IF(MODINP.NE.0) READ(IUREAL(INOC),*) (IOFLG(1,M),M=1,4)
      DO 210 K=1,NLAY
      IOFLG(K,1)=IOFLG(1,1)
      IOFLG(K,2)=IOFLG(1,2)
      IOFLG(K,3)=IOFLG(1,3)
      IOFLG(K,4)=IOFLG(1,4)
  210 CONTINUE
      WRITE(IOUT,211) (IOFLG(1,M),M=1,4)
  211 FORMAT(1X,/1X,'OUTPUT FLAGS FOR ALL LAYERS ARE THE SAME:'/
     1   1X,'  HEAD    DRAWDOWN  HEAD  DRAWDOWN'/
     2   1X,'PRINTOUT  PRINTOUT  SAVE    SAVE'/
     3   1X,34('-')/1X,I5,I10,I8,I8)
      GO TO 600
C
C7------READ IOFLG IN ENTIRETY -- IF CROSS SECTION, READ ONLY ONE VALUE.
  300 IF(IXSEC.EQ.0) THEN
         DO 301 K=1,NLAY
         READ(IUREAL(INOC),*) (IOFLG(K,M),M=1,4)
  301    CONTINUE
         WRITE(IOUT,302) 'OUTPUT FLAGS FOR EACH LAYER:','LAYER'
  302    FORMAT(1X,/1X,A,/
     1   1X,'         HEAD    DRAWDOWN  HEAD  DRAWDOWN'/
     2   1X,A,'  PRINTOUT  PRINTOUT  SAVE    SAVE'/
     3   1X,41('-'))
         WRITE(IOUT,303) (K,(IOFLG(K,M),M=1,4),K=1,NLAY)
  303    FORMAT(1X,I4,I8,I10,I8,I8)
      ELSE
         IF(MODINP.EQ.0) READ(IUREAL(INOC),'(4I10)') (IOFLG(1,M),M=1,4)
         IF(MODINP.NE.0) READ(IUREAL(INOC),*) (IOFLG(1,M),M=1,4)
         WRITE(IOUT,302) 'OUTPUT FLAGS FOR CROSS SECTION:','     '
         WRITE(IOUT,304) (IOFLG(1,M),M=1,4)
  304    FORMAT(1X,I12,I10,I8,I8)
      END IF
C
C9------SAVE FLAGS AND RETURN
C  Budget print flags
  600 IF(IBUDFL.NE.0) THEN
         NTSOUT(5)=NTSOUT(5)+1
         IF(NTSOUT(5).LE.MXSCRN) THEN
            IBDPR(1,NTSOUT(5))=KPER
            IBDPR(2,NTSOUT(5))=KSTP
         END IF
         INONE(5)=0
         IF(KSTP.NE.NSTP(KPER)) IALPER(5)=0
         IF(KSTP.NE.NSTP(KPER) .OR. KPER.NE.NPER) IEND(5)=0
      ELSE
         IALSTP(5)=0
         IF(KSTP.EQ.NSTP(KPER)) IALPER(5)=0
         IF(KSTP.EQ.NSTP(KPER) .AND. KPER.EQ.NPER) IEND(5)=0
      END IF
C  Budget save flags
      IF(ICBCFL.NE.0) THEN
         NTSOUT(6)=NTSOUT(6)+1
         IF(NTSOUT(6).LE.MXSCRN) THEN
            IBDSV(1,NTSOUT(6))=KPER
            IBDSV(2,NTSOUT(6))=KSTP
         END IF
         INONE(6)=0
         IF(KSTP.NE.NSTP(KPER)) IALPER(6)=0
         IF(KSTP.NE.NSTP(KPER) .OR. KPER.NE.NPER) IEND(6)=0
      ELSE
         IALSTP(6)=0
         IF(KSTP.EQ.NSTP(KPER)) IALPER(6)=0
         IF(KSTP.EQ.NSTP(KPER) .AND. KPER.EQ.NPER) IEND(6)=0
      END IF
C  Print head flags
      IF(IHDDFL.NE.0) THEN
         N=0
         NN=NTSOUT(1)+1
         DO 610 K=1,NLAY
         IF(IOFLG(K,1).NE.0) THEN
            N=N+1
            IF(N.LE.15 .AND. NN.LE.MXSCRN) IHDPR(N+2,NN)=K
         END IF
  610    CONTINUE
         IF(N.GT.0) THEN
            INONE(1)=0
            NTSOUT(1)=NN
            IF(NN.LE.MXSCRN) THEN
               IHDPR(1,NN)=KPER
               IHDPR(2,NN)=KSTP
            END IF
            IF(N.EQ.NLAY) THEN
               IF(NN.LE.MXSCRN) IHDPR(3,NN)=0
               IF(KSTP.NE.NSTP(KPER)) IALPER(1)=0
               IF(KSTP.NE.NSTP(KPER) .OR. KPER.NE.NPER) IEND(1)=0
            ELSE
               IEND(1)=0
               IALPER(1)=0
               IALSTP(1)=0
            END IF
         ELSE
            IALSTP(1)=0
            IF(KSTP.EQ.NSTP(KPER)) IALPER(1)=0
            IF(KSTP.EQ.NSTP(KPER) .AND. KPER.EQ.NPER) IEND(1)=0
         END IF
C  Print Drawdown Flags
         N=0
         NN=NTSOUT(2)+1
         DO 620 K=1,NLAY
         IF(IOFLG(K,2).NE.0) THEN
            N=N+1
            IF(N.LE.15 .AND. NN.LE.MXSCRN) IDDPR(N+2,NN)=K
         END IF
  620    CONTINUE
         IF(N.GT.0) THEN
            INONE(2)=0
            NTSOUT(2)=NN
            IF(NN.LE.MXSCRN) THEN
               IDDPR(1,NN)=KPER
               IDDPR(2,NN)=KSTP
            END IF
            IF(N.EQ.NLAY) THEN
               IF(NN.LE.MXSCRN) IDDPR(3,NN)=0
               IF(KSTP.NE.NSTP(KPER)) IALPER(2)=0
               IF(KSTP.NE.NSTP(KPER) .OR. KPER.NE.NPER) IEND(2)=0
            ELSE
               IEND(2)=0
               IALPER(2)=0
               IALSTP(2)=0
            END IF
         ELSE
            IALSTP(2)=0
            IF(KSTP.EQ.NSTP(KPER)) IALPER(2)=0
            IF(KSTP.EQ.NSTP(KPER) .AND. KPER.EQ.NPER) IEND(2)=0
         END IF
C  Save head flags
         N=0
         NN=NTSOUT(3)+1
         DO 630 K=1,NLAY
         IF(IOFLG(K,3).NE.0) THEN
            N=N+1
            IF(N.LE.15 .AND. NN.LE.MXSCRN) IHDSV(N+2,NN)=K
         END IF
  630    CONTINUE
         IF(N.GT.0) THEN
            INONE(3)=0
            NTSOUT(3)=NN
            IF(NN.LE.MXSCRN) THEN
               IHDSV(1,NN)=KPER
               IHDSV(2,NN)=KSTP
            END IF
            IF(N.EQ.NLAY) THEN
               IF(NN.LE.MXSCRN) IHDSV(3,NN)=0
               IF(KSTP.NE.NSTP(KPER)) IALPER(3)=0
               IF(KSTP.NE.NSTP(KPER) .OR. KPER.NE.NPER) IEND(3)=0
            ELSE
               IEND(3)=0
               IALPER(3)=0
               IALSTP(3)=0
            END IF
         ELSE
            IALSTP(3)=0
            IF(KSTP.EQ.NSTP(KPER)) IALPER(3)=0
            IF(KSTP.EQ.NSTP(KPER) .AND. KPER.EQ.NPER) IEND(3)=0
         END IF
C  Save drawdown flags
         N=0
         NN=NTSOUT(4)+1
         DO 640 K=1,NLAY
         IF(IOFLG(K,4).NE.0) THEN
            N=N+1
            IF(N.LE.15 .AND. NN.LE.MXSCRN) IDDSV(N+2,NN)=K
         END IF
  640    CONTINUE
         IF(N.GT.0) THEN
            INONE(4)=0
            NTSOUT(4)=NN
            IF(NN.LE.MXSCRN) THEN
               IDDSV(1,NN)=KPER
               IDDSV(2,NN)=KSTP
            END IF
            IF(N.EQ.NLAY) THEN
               IF(NN.LE.MXSCRN) IDDSV(3,NN)=0
               IF(KSTP.NE.NSTP(KPER)) IALPER(4)=0
               IF(KSTP.NE.NSTP(KPER) .OR. KPER.NE.NPER) IEND(4)=0
            ELSE
               IEND(4)=0
               IALPER(4)=0
               IALSTP(4)=0
            END IF
         ELSE
            IALSTP(4)=0
            IF(KSTP.EQ.NSTP(KPER)) IALPER(4)=0
            IF(KSTP.EQ.NSTP(KPER) .AND. KPER.EQ.NPER) IEND(4)=0
         END IF
C
      ELSE
C  IHDDFL is 0, so there is no head or drawdown print or save
         IALSTP(1)=0
         IALSTP(2)=0
         IALSTP(3)=0
         IALSTP(4)=0
         IF(KSTP.EQ.NSTP(KPER)) THEN
            IALPER(1)=0
            IALPER(2)=0
            IALPER(3)=0
            IALPER(4)=0
         END IF
         IF(KSTP.EQ.NSTP(KPER) .AND. KPER.EQ.NPER) THEN
            IEND(1)=0
            IEND(2)=0
            IEND(3)=0
            IEND(4)=0
         END IF
      END IF
C
      RETURN
      END
      SUBROUTINE SBASN(IOFLG,NLAY,IHDDFL,IBUDFL,ICBCFL,IPEROC,ITSOC,
     1            KPER,KSTP,INOC,IOUT,IBDOPT)
C     ******************************************************************
C     SET OUTPUT FLAGS USING ALPHABETIC OUTPUT CONTROL INPUT STRUCTURE
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DIMENSION IOFLG(200,4)
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
C
C1------ERROR IF OUTPUT CONTROL TIME STEP PRECEDES CURRENT SIMULATION
C1------TIME STEP.
      IF((IPEROC.LT.KPER).OR.(IPEROC.EQ.KPER .AND. ITSOC.LT.KSTP)) THEN
         WRITE(IOUT,5) IPEROC,ITSOC,KPER,KSTP
    5    FORMAT(1X,/1X,'OUTPUT CONTROL WAS SPECIFIED FOR A NONEXISTENT',
     1   ' TIME STEP',/
     2   1X,'OR OUTPUT CONTROL DATA ARE NOT ENTERED IN ASCENDING ORDER',
     3   /1X,'OUTPUT CONTROL STRESS PERIOD',I3,'   TIME STEP',I3,/
     4   1X,'MODEL STRESS PERIOD',I3,'   TIME STEP',I3,/
     5   1X,'APPLYING THE SPECIFIED OUTPUT CONTROL TO THE CURRENT TIME',
     6   ' STEP')
         IPEROC=KPER
         ITSOC=KSTP
      END IF
C
C2------CLEAR I/O FLAGS.
      IHDDFL=0
      IBUDFL=0
      ICBCFL=0
      DO 10 I=1,4
      DO 10 J=1,NLAY
      IOFLG(J,I)=0
10    CONTINUE
C
C3------IF OUTPUT CONTROL TIME STEP DOES NOT MATCH SIMULATION TIME STEP,
C3------WRITE MESSAGE THAT THERE IS NO OUTPUT CONTROL THIS TIME STEP,
C3------AND RETURN.
      IF(IPEROC.NE.KPER .OR. ITSOC.NE.KSTP) THEN
         WRITE(IOUT,91) KPER,KSTP
91       FORMAT(1X,/1X,'NO OUTPUT CONTROL FOR STRESS PERIOD',I3,
     1              '   TIME STEP',I3)
         RETURN
      END IF
C
C4------OUTPUT CONTROL TIME STEP MATCHES SIMULATION TIME STEP.
      WRITE(IOUT,11) IPEROC,ITSOC
11    FORMAT(1X,/1X,'OUTPUT CONTROL FOR STRESS PERIOD',I3,
     1              '   TIME STEP',I3)
C
C4A-----OUTPUT CONTROL MATCHES SIMULATION TIME.  READ NEXT OUTPUT
C4A-----RECORD; SKIP ANY BLANK LINES.
50    READ(INOC,'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 50
C
C4A1----LOOK FOR "PERIOD", WHICH TERMINATES OUTPUT CONTROL FOR CURRENT
C4A1----TIME STEP.  IF FOUND, DECODE TIME STEP FOR NEXT OUTPUT.
      LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INOC)
      IF(LINE(ISTART:ISTOP).EQ.'PERIOD') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPEROC,R,IOUT,INOC)
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INOC)
         IF(LINE(ISTART:ISTOP).NE.'STEP') GO TO 2000
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ITSOC,R,IOUT,INOC)
         RETURN
C
C4A2----LOOK FOR "PRINT", WHICH MAY REFER TO "BUDGET", "HEAD", OR
C4A2----"DRAWDOWN".
      ELSE IF(LINE(ISTART:ISTOP).EQ.'PRINT') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INOC)
         IF(LINE(ISTART:ISTOP).EQ.'BUDGET') THEN
            WRITE(IOUT,53)
53          FORMAT(4X,'PRINT BUDGET')
            IBUDFL=1
         ELSE IF(LINE(ISTART:ISTOP).EQ.'HEAD') THEN
            CALL SBASL(1,LINE,LLOC,IOFLG,NLAY,IOUT,'PRINT HEAD',
     1              INOC)
            IHDDFL=1
         ELSE IF(LINE(ISTART:ISTOP).EQ.'DRAWDOWN') THEN
            CALL SBASL(2,LINE,LLOC,IOFLG,NLAY,IOUT,
     1              'PRINT DRAWDOWN',INOC)
            IHDDFL=1
         ELSE
            GO TO 2000
         END IF
C
C4A3----LOOK FOR "SAVE", WHICH MAY REFER TO "BUDGET", "HEAD", OR
C4A3----"DRAWDOWN".
      ELSE IF(LINE(ISTART:ISTOP).EQ.'SAVE') THEN
         CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,R,IOUT,INOC)
         IF(LINE(ISTART:ISTOP).EQ.'BUDGET') THEN
            WRITE(IOUT,57)
57          FORMAT(4X,'SAVE BUDGET')
            ICBCFL=IBDOPT
         ELSE IF(LINE(ISTART:ISTOP).EQ.'HEAD') THEN
            CALL SBASL(3,LINE,LLOC,IOFLG,NLAY,IOUT,'SAVE HEAD',INOC)
            IHDDFL=1
         ELSE IF(LINE(ISTART:ISTOP).EQ.'DRAWDOWN') THEN
            CALL SBASL(4,LINE,LLOC,IOFLG,NLAY,IOUT,'SAVE DRAWDOWN',
     1          INOC)
            IHDDFL=1
         ELSE
            GO TO 2000
         END IF
C
C4A4----WHEN NO KNOWN ALPHABETIC WORDS ARE FOUND, THERE IS AN ERROR.
      ELSE
         GO TO 2000
C
C4B-----AFTER SUCCESSFULLY DECODING ONE RECORD, READ ANOTHER.
      END IF
      GO TO 50
C
C5------END OF FILE WHILE READING AN OUTPUT CONTROL RECORD, SO THERE
C5------WILL BE NO FURTHER OUTPUT.  SET IPEROC AND ITSOC HIGH ENOUGH
C5------THAT THE MODEL TIME WILL NEVER MATCH THEM.
1000  IPEROC=9999
      ITSOC=9999
      RETURN
C
C6------ERROR DECODING ALPHABETIC INPUT STRUCTURE.
2000  WRITE(IOUT,2001) LINE
2001  FORMAT(1X,/1X,'ERROR READING OUTPUT CONTROL INPUT DATA:'/1X,A80)
C      STOP
      CALL MFISTP
      END
      SUBROUTINE SBASL(IPOS,LINE,LLOC,IOFLG,NLAY,IOUT,LABEL,INOC)
C     ******************************************************************
C     WHEN USING ALPHABETIC OUTPUT CONTROL, DECODE LAYER
C     NUMBERS FOR PRINTING OR SAVING HEAD OR DRAWDOWN
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DIMENSION IOFLG(200,4)
      CHARACTER*80 LINE
      CHARACTER*(*) LABEL
      DIMENSION LAYER(200)
C     ------------------------------------------------------------------
C
C1------INITIALIZE LAYER COUNTER.
      NSET=0
C
C2------CHECK FOR A VALID LAYER NUMBER.  WHEN FOUND, SET FLAG AND
C2------REPEAT.
10    CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,L,R,-1,INOC)
      IF(L.GT.0 .AND. L.LE.NLAY) THEN
         NSET=NSET+1
         LAYER(NSET)=L
         IOFLG(L,IPOS)=1
         GO TO 10
      END IF
C
C3------DONE CHECKING FOR LAYER NUMBERS.  IF NO LAYER NUMBERS WERE
C3------FOUND, SET FLAGS FOR ALL LAYERS.
      IF(NSET.EQ.0) THEN
         DO 110 K=1,NLAY
         IOFLG(K,IPOS)=1
110      CONTINUE
         WRITE(IOUT,111) LABEL
111      FORMAT(4X,A,' FOR ALL LAYERS')
C
C4------IF ONE OR MORE LAYER NUMBERS WERE FOUND, PRINT THE NUMBERS.
      ELSE
         WRITE(IOUT,112) LABEL,(LAYER(M),M=1,NSET)
112      FORMAT(4X,A,' FOR LAYERS:',(1X,15I3))
      END IF
C
C5------RETURN.
      RETURN
      END
      SUBROUTINE OCFREQ(INONE,IEND,IALPER,IALSTP,IBDSAM)
C     ******************************************************************
C     Set the Output Control frequency flags
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
      DIMENSION INONE(6),IEND(6),IALPER(6),IALSTP(6)
C
      IF(INONE(1).NE.0) THEN
         IHEDPR=1
      ELSE IF(IEND(1).NE.0) THEN
         IHEDPR=2
      ELSE IF(IALPER(1).NE.0) THEN
         IHEDPR=3
      ELSE IF(IALSTP(1).NE.0) THEN
         IHEDPR=4
      ELSE
         IHEDPR=5
      END IF
C
      IF(INONE(2).NE.0) THEN
         IDDNPR=1
      ELSE IF(IEND(2).NE.0) THEN
         IDDNPR=2
      ELSE IF(IALPER(2).NE.0) THEN
         IDDNPR=3
      ELSE IF(IALSTP(2).NE.0) THEN
         IDDNPR=4
      ELSE
         IDDNPR=5
      END IF
C
      IF(INONE(3).NE.0) THEN
         IHEDSV=1
      ELSE IF(IEND(3).NE.0) THEN
         IHEDSV=2
      ELSE IF(IALPER(3).NE.0) THEN
         IHEDSV=3
      ELSE IF(IALSTP(3).NE.0) THEN
         IHEDSV=4
      ELSE
         IHEDSV=5
      END IF
C
      IF(INONE(4).NE.0) THEN
         IDDNSV=1
      ELSE IF(IEND(4).NE.0) THEN
         IDDNSV=2
      ELSE IF(IALPER(4).NE.0) THEN
         IDDNSV=3
      ELSE IF(IALSTP(4).NE.0) THEN
         IDDNSV=4
      ELSE
         IDDNSV=5
      END IF
C
      IF(INONE(5).NE.0) THEN
         IBUDPR=1
      ELSE IF(IEND(5).NE.0) THEN
         IBUDPR=2
      ELSE IF(IALPER(5).NE.0) THEN
         IBUDPR=3
      ELSE IF(IALSTP(5).NE.0) THEN
         IBUDPR=4
      ELSE
         IBUDPR=5
      END IF
      IF(IBUDPR.LT.3) IBUDPR=3
C
      IF(INONE(6).NE.0) THEN
         IBUDSV=1
      ELSE IF(IEND(6).NE.0) THEN
         IBUDSV=2
      ELSE IF(IALPER(6).NE.0) THEN
         IBUDSV=3
      ELSE IF(IALSTP(6).NE.0) THEN
         IBUDSV=4
      ELSE
         IBUDSV=5
      END IF
C
C  Match up IHEDSV and IHEDUN -- also match IDDNSV and IDDNUN
      IF(IHEDUN.GT.0) IFNUSE(IHEDUN)=0
      IF(IDDNUN.GT.0) IFNUSE(IDDNUN)=0
      IF(IHEDUN.EQ.0) IHEDSV=1
      IF(IHEDSV.EQ.1) IHEDUN=0
      IF(IDDNUN.EQ.0) IDDNSV=1
      IF(IDDNSV.EQ.1) IDDNUN=0
      IF(IHEDUN.GT.0) IFNUSE(IHEDUN)=IUNIT(12)
      IF(IDDNUN.GT.0) IFNUSE(IDDNUN)=IUNIT(12)
C
C  Set IBUDUN as appropriate -- IBDSAM will be >0 when all packages that
C  contribute to the budget send CBC output to the same file.
C  If IBDSAM is 0, CBC output goes to different units
C  If IBDSAM is -1, all CBC output gets printed in listing file
C  If IBDSAM is -2, all packages have CBC flag of 0
      IF(IBDSAM.GT.0) IBUDUN=IBDSAM
      IF(IBUDUN.GT.0) THEN
C  Remove the use flag for the budget file if all output goes
C  to one file.  This flag will be reset if the file is actually used.
         IFNUSE(IBUDUN)=0
C  If the budget file does not exist, then output cannot go to it.
         IF(FILTYP(IBUDUN).EQ.' ') IBUDUN=0
      END IF
C  If budget output frequency is NONE, then eliminate the budget file
      IF(IBUDSV.EQ.1) IBUDUN=0
C  If after all the above there is still a budget file, set its use flag.
      IF(IBUDUN.GT.0) IFNUSE(IBUDUN)=IUNIT(12)
C
C  When there is not a single budget file for all packages, see if there
C  are any individual budget files.  If not, set the budget frequency to
C  NONE
      IF(IBUDUN.EQ.0) THEN
         DO 100 I=1,40
         IF(IUNIT2(I).NE.0) GO TO 102
100      CONTINUE
         IBUDSV=1
102      CONTINUE
      END IF
C
C  Clean up any files that were deactivated
      CALL FNMRMV
C
      RETURN
      END
      SUBROUTINE OCED
C  *********************************************************************
C  Edit Output Control data
C  *********************************************************************
C
      INCLUDE 'mfi.gbl'
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
C
      IF(IUNIT(12).EQ.0) THEN
         CALL FINDUN(22,IU,'OC')
         IUNIT(12)=IU
         CHEDFM='(BINARY)'
         CDDNFM='(BINARY)'
         IHEDPR=3
         IDDNPR=1
         IHEDSV=1
         IDDNSV=1
         IBUDPR=3
         IBUDSV=1
      END IF
C
C  Main Output Control menu
      IOPT=1
10    CALL QRESP(MESSFL,306,1,IOPT)
C
      IF(IOPT.EQ.1) THEN
C  Head and drawdown files and formats
         CALL OCED1
C
      ELSE IF(IOPT.EQ.2) THEN
C  CBC budget files
         CALL OCED2
C
      ELSE IF(IOPT.EQ.3) THEN
C  When to print head
         CALL QRESP(MESSFL,306,5,IHEDPR)
         IF(IHEDPR.EQ.5) CALL EDTIM(306,6,IHDPR,1)
C
      ELSE IF(IOPT.EQ.4) THEN
C  When to print drawdown
         CALL QRESP(MESSFL,306,7,IDDNPR)
         IF(IDDNPR.EQ.5) CALL EDTIM(306,8,IDDPR,2)
C
      ELSE IF(IOPT.EQ.5) THEN
C  When to save head
         CALL QRESP(MESSFL,306,9,IHEDSV)
         IF(IHEDSV.EQ.5) CALL EDTIM(306,10,IHDSV,3)
         IF(IHEDUN.EQ.0 .AND. IHEDSV.GT.1) CALL OCED1
C
      ELSE IF(IOPT.EQ.6) THEN
C  When to save drawdown
         CALL QRESP(MESSFL,306,11,IDDNSV)
         IF(IDDNSV.EQ.5) CALL EDTIM(306,12,IDDSV,4)
         IF(IDDNUN.EQ.0 .AND. IDDNSV.GT.1) CALL OCED1
C
      ELSE IF(IOPT.EQ.7) THEN
C  When to print overall budget
         IBUDPR=IBUDPR-2
         CALL QRESP(MESSFL,306,13,IBUDPR)
         IBUDPR=IBUDPR+2
         IF(IBUDPR.EQ.5) CALL EDTIM(306,14,IBDPR,0)
C
      ELSE IF(IOPT.EQ.8) THEN
C  When to save cbc budget
         CALL QRESP(MESSFL,306,15,IBUDSV)
         IF(IBUDSV.EQ.5) CALL EDTIM(306,16,IBDSV,0)
         IF(IBUDUN.EQ.0 .AND. IBUDSV.GT.1) THEN
            DO 80 I=1,40
            IF(IUNIT2(I).NE.0) GO TO 82
80          CONTINUE
            CALL OCED2
82          CONTINUE
         END IF
C
      ELSE
C  End of Output Control data entry
         CALL OCSV(IUNDEF,1)
         RETURN
      END IF
C
      IOPT=IOPT+1
      GO TO 10
C
      END
      SUBROUTINE OCED1()
C     ******************************************************************
C     Edit head and drawdown files and formats
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
C
      CHARACTER*78 HEDFIL,DDNFIL
      CHARACTER*18 FTYP
C
C  Initialize screen
15    IF(IHEDUN.LE.0) THEN
         IF(IUCASE.NE.0) THEN
            HEDFIL=DSNAME(1:NDSNAM)//'.HED'
         ELSE
            HEDFIL=DSNAME(1:NDSNAM)//'.hed'
         END IF
      ELSE
         HEDFIL=FILNAM(IHEDUN)
      END IF
C
      IF(IDDNUN.LE.0) THEN
         IF(IUCASE.NE.0) THEN
            DDNFIL=DSNAME(1:NDSNAM)//'.DDN'
         ELSE
            DDNFIL=DSNAME(1:NDSNAM)//'.ddn'
         END IF
      ELSE
         DDNFIL=FILNAM(IDDNUN)
      END IF
C  Choose original or new model
      IF(MODOUT.EQ.0) THEN
         CALL Q1INIT(MESSFL,306,17)
         CALL QSTCTB(1,78,78,1,HEDFIL)
         CALL QSTCTB(1,78,78,2,DDNFIL)
      ELSE
         CALL Q1INIT(MESSFL,306,2)
         CALL QSTCTB(1,20,20,2,CHEDFM)
         CALL QSTCTB(1,20,20,4,CDDNFM)
         CALL QSTCTB(1,78,78,1,HEDFIL)
         CALL QSTCTB(1,78,78,3,DDNFIL)
      END IF
      CALL QSETIB(1,1,IHEDFM)
      CALL QSETIB(1,2,IDDNFM)
C
      CALL Q1EDIT(IRET)
      IF(IRET.EQ.-1) GO TO 15
C
C  Get parameters from screen
      CALL QGETIB(1,1,IHEDFM)
      CALL QGETIB(1,2,IDDNFM)
      IF(MODOUT.EQ.0) THEN
         CALL QGTCTB(1,78,78,1,HEDFIL)
         CALL QGTCTB(1,78,78,2,DDNFIL)
      ELSE
         CALL QGTCTB(1,78,78,1,HEDFIL)
         CALL QGTCTB(1,20,20,2,CHEDFM)
         CALL QGTCTB(1,78,78,3,DDNFIL)
         CALL QGTCTB(1,20,20,4,CDDNFM)
      END IF
      CALL USTLFT(HEDFIL,78)
      IF(IUCASE.NE.0) CALL USTRUC(HEDFIL,78)
      IF(HEDFIL.EQ.' ') THEN
         IF(IUCASE.NE.0) HEDFIL=DSNAME(1:NDSNAM)//'.HED'
         IF(IUCASE.EQ.0) HEDFIL=DSNAME(1:NDSNAM)//'.hed'
      END IF
      CALL FMTCHK(CHEDFM,IERR)
      IF(IERR.NE.0) GO TO 15
      CALL USTLFT(DDNFIL,78)
      IF(IUCASE.NE.0) CALL USTRUC(DDNFIL,78)
      IF(DDNFIL.EQ.' ') THEN
         IF(IUCASE.NE.0) DDNFIL=DSNAME(1:NDSNAM)//'.DDN'
         IF(IUCASE.EQ.0) DDNFIL=DSNAME(1:NDSNAM)//'.ddn'
      END IF
      CALL FMTCHK(CDDNFM,IERR)
      IF(IERR.NE.0) GO TO 15
      FTYP='DATA'
      IF(CHEDFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
      CALL FNMSV3(HEDFIL,IUTMP,FTYP,IUNIT(12),0)
      IF(IUTMP.LE.0) GO TO 15
      IHEDUN=IUTMP
      FTYP='DATA'
      IF(CDDNFM.EQ.'(BINARY)') FTYP='DATA(BINARY)'
      CALL FNMSV3(DDNFIL,IUTMP,FTYP,IUNIT(12),0)
      IF(IUTMP.LE.0) GO TO 15
      IDDNUN=IUTMP
C
      RETURN
      END
      SUBROUTINE OCED2()
C     ******************************************************************
C     Edit budget files
C     ******************************************************************
      INCLUDE 'mfi.gbl'
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
C
      DIMENSION IBUF(1000)
      CHARACTER*78 BUDFIL,CTMP
      CHARACTER*3 CFTYP(40)
      CHARACTER*70 CVAL(40)
C
24    IF(IUCASE.NE.0) BUDFIL=DSNAME(1:NDSNAM)//'.BUD'
      IF(IUCASE.EQ.0) BUDFIL=DSNAME(1:NDSNAM)//'.bud'
      IBDCHO=2
      IF(IBUDUN.GT.0) THEN
         IBDCHO=1
         BUDFIL=FILNAM(IBUDUN)
      END IF
C  The specific screen depends on original or new model
      IF(MODOUT.EQ.0) THEN
         CALL Q1INIT(MESSFL,306,19)
         CALL QSETOP(1,1,1,1,IBDCHO)
      ELSE
         CALL Q1INIT(MESSFL,306,3)
         IBUF(1)=1
         IBUF(2)=1
         IBUF(3)=1
         IBUF(4)=1
         IBUF(5)=IBDOPT
         IBUF(6)=IBDCHO
         CALL QSETOP(2,2,IBUF(1),IBUF(3),IBUF(5))
      END IF
      CALL QSTCTB(1,78,78,1,BUDFIL)
C  Activate screen
      CALL Q1EDIT(IRET)
      IF(IRET.EQ.-1) GO TO 24
C
      CALL QGTCTB(1,78,78,1,BUDFIL)
      CALL USTLFT(BUDFIL,78)
      IF(IUCASE.NE.0) CALL USTRUC(BUDFIL,78)
C  For original model get 1 option -- for new model get 2 options
      IF(MODOUT.EQ.0) THEN
         CALL QGETOP(1,IBDCHO)
      ELSE
         CALL QGETOP(2,IBUF)
         IBDOPT=IBUF(1)
         IBDCHO=IBUF(2)
      END IF
C  Process budget choice option -- ALL IN ONE FILE (1) or CHOOSE (2)
      IF(IBDCHO.EQ.1) THEN
         CALL FNMSV3(BUDFIL,IUTMP,'DATA(BINARY)',IUNIT(12),1)
         IF(IUTMP.LE.0) GO TO 24
         IBUDUN=IUTMP
      ELSE
C  The budget file is chosen for each option
25       N=0
         IBUDUN=0
C  Determine initial choices for the budget file for each option
         DO 26 I=1,39
         IF(IUNIT(I).EQ.0 .OR. (I.GT.8 .AND. I.LT.18) .OR. I.GT.18)
     1                     GO TO 26
         N=N+1
         CFTYP(N)=FILTYP(IUNIT(I))
         IF(IUNIT2(I).EQ.-1) THEN
            CVAL(N)='PRINT'
         ELSE IF(IUNIT2(I).GT.0) THEN
            CVAL(N)=FILNAM(IUNIT2(I))
         ELSE
            CVAL(N)=' '
         END IF
26       CONTINUE
         IF(N.GT.0) THEN
C  Initialize screen
27          CALL Q2INIT(MESSFL,306,4)
C  Set initial values
            CALL Q2SCTF(1,3,N,CFTYP)
            CALL Q2SCTF(2,70,N,CVAL)
C  Activate screen
            CALL Q2EDIT(N,IRET)
            IF(IRET.EQ.-1) GO TO 27
C  Get responses and process them
            CALL Q2GCTF(2,70,N,CVAL)
            N=0
            DO 28 I=1,39
            IF(IUNIT(I).EQ.0 .OR. (I.GT.8 .AND. I.LT.18) .OR. I.GT.18)
     1                     GO TO 28
            N=N+1
            CTMP=CVAL(N)
            CALL USTLFT(CTMP,78)
            IF(IUCASE.NE.0) CALL USTRUC(CTMP,78)
            IF(CTMP.EQ.'PRINT' .OR. CTMP.EQ.'print') THEN
               IUNIT2(I)=-1
            ELSE IF(CTMP.EQ.' ') THEN
               IUNIT2(I)=0
            ELSE
               CALL FNMSV3(CTMP,IUTMP,'DATA(BINARY)',IUNIT(12),1)
               IF(IUTMP.LE.0) GO TO 25
               IUNIT2(I)=IUTMP
            END IF
28          CONTINUE
         END IF
      END IF
C
      RETURN
      END
      SUBROUTINE EDTIM(ICLU,IGRP,ILIST,LAYFLG)
C     ******************************************************************
C     Get times at which output will occur
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
      DIMENSION ILIST(17,MXSCRN)
      DIMENSION IIBUF(2,MXSCRN)
      CHARACTER*60 CBUF(MXSCRN)
      CHARACTER*80 LINE
C
C  Define initial values
      N=0
      DO 20 NLIST=1,MXSCRN
      M=ILIST(1,NLIST)
      L=ILIST(2,NLIST)
      IF(M.LT.1 .OR. M.GT.NPER .OR. L.LT.1 .OR. L.GT.NSTP(M)) GO TO 20
      N=N+1
      IIBUF(1,N)=M
      IIBUF(2,N)=L
      IF(LAYFLG.GT.0) THEN
         CALL CHRLAY(ILIST,NLIST,LINE)
         CBUF(N)=LINE
      END IF
20    CONTINUE
      IF(N.LT.MXSCRN) THEN
         DO 25 L=N+1,MXSCRN
         IIBUF(1,L)=M
         IIBUF(2,L)=L
         IF(LAYFLG.GT.0) CBUF(L)=' '
25       CONTINUE
      END IF
C
C  Initialize screen
26    CALL Q2INIT(MESSFL,ICLU,IGRP)
C  Set initial values
      CALL Q2STIB(2,1,MXSCRN,IIBUF(1,1))
      IF(LAYFLG.GT.0) CALL Q2SCTF(1,60,MXSCRN,CBUF)
C  Activate screen
      CALL Q2EDIT(MXSCRN,IRET)
      IF(IRET.EQ.-1) GO TO 26
C  Process values
      CALL Q2GTIB(2,1,MXSCRN,IIBUF(1,1))
      IF(LAYFLG.GT.0) CALL Q2GCTF(1,60,MXSCRN,CBUF)
      N=0
      IREJEC=0
      DO 30 L=1,MXSCRN
      KPER=IIBUF(1,L)
      IF(KPER.GT.0 .AND. KPER.LE.NPER) THEN
         KSTP=IIBUF(2,L)
         IF(KSTP.GT.0 .AND. KSTP.LE.NSTP(KPER)) THEN
            N=N+1
            ILIST(1,N)=KPER
            ILIST(2,N)=KSTP
            IF(LAYFLG.GT.0) THEN
               LINE=CBUF(L)
               CALL INTLAY(LINE,N,ILIST)
            END IF
         ELSE
            IREJEC=IREJEC+1
         END IF
      ELSE
         IF(KPER.GT.0) IREJEC=IREJEC+1
      END IF
30    CONTINUE
C  Tell user if some of the times were rejected because they were outside
C  the range of stress periods and time steps.
      IF(IREJEC.GT.0) CALL PRNTXT(MESSFL,306,18)
C  Fill in unused values in the list
      IF(N.LT.MXSCRN) THEN
         DO 35 M=N+1,MXSCRN
         ILIST(1,M)=-999
         ILIST(2,M)=-999
35       CONTINUE
      END IF
C
C  Sort the list
      CALL LSTSRT(ILIST,MXSCRN,N)
C
      RETURN
      END
      SUBROUTINE CHRLAY(ILIST,N,LINE)
C     ******************************************************************
C     Convert a list of integer layer numbers into a text string
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION ILIST(17,MXSCRN)
      CHARACTER*80 LINE
      CHARACTER*4 CTMP
C
      LINE=' '
C
      DO 10 I=1,15
      IF(ILIST(I+2,N).LE.0) RETURN
      WRITE(CTMP,'(I4)') ILIST(I+2,N)
      I2=I*4
      I1=I2-3
      LINE(I1:I2)=CTMP
10    CONTINUE
C
      END
      SUBROUTINE INTLAY(LINE,N,ILIST)
C     ******************************************************************
C     Convert a list of layer numbers from characters into integers
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION ILIST(17,MXSCRN)
      CHARACTER*80 LINE
C     ------------------------------------------------------------------
C
C1------INITIALIZE LIST OF INTEGERS TO 0
      DO 5 K=3,17
      ILIST(K,N)=0
5     CONTINUE
      NSET=0
C
C2------CHECK FOR A VALID LAYER NUMBER.  WHEN FOUND, SET FLAG AND
C2------REPEAT.
      LLOC=1
10    CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,L,R,-1,0)
      IF(L.GT.0 .AND. L.LE.NLAY .AND. NSET.LT.15) THEN
         NSET=NSET+1
         ILIST(NSET+2,N)=L
         GO TO 10
      END IF
C
C5------RETURN.
      RETURN
      END
      SUBROUTINE LSTSRT(ILIST,MXSCRN,N)
C     ******************************************************************
C     Sort a list of output control times -- simple bubble sort
C     ******************************************************************
      DIMENSION ILIST(17,MXSCRN)
      IF(N.LT.2) RETURN
      DO 50 I=1,N-1
      DO 50 J=1,N-I
      IF((ILIST(1,J).GT.ILIST(1,J+1)) .OR.
     1 (ILIST(1,J).EQ.ILIST(1,J+1) .AND. ILIST(2,J).GT.ILIST(2,J+1)) )
     2     THEN
         DO 40 K=1,17
         ITMP=ILIST(K,J)
         ILIST(K,J)=ILIST(K,J+1)
         ILIST(K,J+1)=ITMP
40       CONTINUE
      END IF
50    CONTINUE
      RETURN
      END
      SUBROUTINE OCSV(IUNDEF,IWRFLG)
C     ******************************************************************
C     SAVE DATA FOR OUTPUT CONTROL
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
C     ------------------------------------------------------------------
      IF(IUNIT(12).EQ.0) THEN
         IUNDEF=-1
         RETURN
      END IF
      IUNDEF=0
      IF(IWRFLG.LE.0) RETURN
C
      DO 5 I=1,MXFNAM
      IF(IFNUSE(I).EQ.IUNIT(12)) IFNUSE(I)=0
5     CONTINUE
      IFNUSE(IUNIT(12))=IUNIT(12)
C
      IF(IUREAL(IUNIT(12)).EQ.0) CALL REALUN(IUNIT(12))
      IF(IHEDUN.GT.0) THEN
         IF(IUREAL(IHEDUN).EQ.0) CALL REALUN(IHEDUN)
      END IF
      IF(IDDNUN.GT.0) THEN
         IF(IUREAL(IDDNUN).EQ.0) CALL REALUN(IDDNUN)
      END IF
      IFIL=IUMISC
      IF(IWRFLG.EQ.1) OPEN(FILE='MFI.OC',UNIT=IFIL)
      IF(IWRFLG.GT.1) OPEN(FILE=FILNAM(IUNIT(12)),UNIT=IFIL)
      IBDSVF=0
      IHDSVF=0
      IDDSVF=0
      IDDPRF=0
      IDUM=0
C
C  Choose between original and new model
      IF(MODOUT.EQ.0) THEN
         CALL OCSVOR(IFIL,IBDSVF,IHDSVF,IDDSVF,IDDPRF)
         GO TO 500
      END IF
C
      WRITE(IFIL,'(A,I4)') 'HEAD PRINT FORMAT',IHEDFM
      WRITE(IFIL,'(A,I4)') 'DRAWDOWN PRINT FORMAT',IDDNFM
      IF(IHEDUN.GT.0) WRITE(IFIL,'(A,I4)')
     1             'HEAD SAVE UNIT',IUREAL(IHEDUN)
      IF(CHEDFM.NE.'(BINARY)') THEN
         IF(LBHDSV.EQ.0) WRITE(IFIL,'(A,A)') 'HEAD SAVE FORMAT ',CHEDFM
         IF(LBHDSV.NE.0) WRITE(IFIL,'(A,A,A)') 'HEAD SAVE FORMAT ',
     1               CHEDFM,' LABEL'
      END IF
      IF(IDDNUN.GT.0) WRITE(IFIL,'(A,I4)')
     1              'DRAWDOWN SAVE UNIT',IUREAL(IDDNUN)
      IF(CDDNFM.NE.'(BINARY)') THEN
         IF(LBDDSV.EQ.0) WRITE(IFIL,'(A,A)') 'DRAWDOWN SAVE FORMAT ',
     1               CDDNFM
         IF(LBDDSV.NE.0) WRITE(IFIL,'(A,A,A)') 'DRAWDOWN SAVE FORMAT ',
     1               CDDNFM,' LABEL'
      END IF
      IF(IBDOPT.EQ.2) WRITE(IFIL,'(A)') 'COMPACT BUDGET FILES'
C
      NBDPR=1
      NBDSV=1
      NHDPR=1
      NDDPR=1
      NHDSV=1
      NDDSV=1
C  Loop through all time steps specifying when output is desired
      DO 100 N=1,NPER
      DO 99 M=1,NSTP(N)
      ILBL=0
C  Print overall budget
      IF(IBUDPR.EQ.3) THEN
         IF(M.EQ.NSTP(N))
     1       CALL OCOUT('PRINT BUDGET',ILBL,IFIL,N,M,0,IBDPR,IDUM)
      ELSE IF(IBUDPR.EQ.4) THEN
         CALL OCOUT('PRINT BUDGET',ILBL,IFIL,N,M,0,IBDPR,IDUM)
      ELSE IF(IBUDPR.EQ.5) THEN
10       IF(NBDPR.LE.MXSCRN) THEN
            IF(IBDPR(1,NBDPR).EQ.N .AND. IBDPR(2,NBDPR).EQ.M) THEN
               CALL OCOUT('PRINT BUDGET',ILBL,IFIL,N,M,0,IBDPR,IDUM)
               NBDPR=NBDPR+1
            ELSE IF(IBDPR(1,NBDPR).LE.0) THEN
               NBDPR=MXSCRN+1
            ELSE IF((IBDPR(1,NBDPR).LT.N) .OR.
     1         (IBDPR(1,NBDPR).EQ.N .AND. IBDPR(2,NBDPR).LT.M) ) THEN
               NBDPR=NBDPR+1
               GO TO 10
            END IF
         END IF
      END IF
C  Save CBC budget
      IF(IBUDSV.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) CALL OCOUT('SAVE BUDGET',
     1         ILBL,IFIL,N,M,0,IBDSV,IBDSVF)
      ELSE IF(IBUDSV.EQ.3) THEN
         IF(M.EQ.NSTP(N)) CALL OCOUT('SAVE BUDGET',ILBL,IFIL,N,M,0,
     1         IBDSV,IBDSVF)
      ELSE IF(IBUDSV.EQ.4) THEN
         CALL OCOUT('SAVE BUDGET',ILBL,IFIL,N,M,0,IBDSV,IBDSVF)
      ELSE IF(IBUDSV.EQ.5) THEN
20       IF(NBDSV.LE.MXSCRN) THEN
            IF(IBDSV(1,NBDSV).EQ.N .AND. IBDSV(2,NBDSV).EQ.M) THEN
               CALL OCOUT('SAVE BUDGET',ILBL,IFIL,N,M,0,IBDSV,IBDSVF)
               NBDSV=NBDSV+1
            ELSE IF(IBDSV(1,NBDSV).LE.0) THEN
               NBDSV=MXSCRN+1
            ELSE IF((IBDSV(1,NBDSV).LT.N) .OR.
     1         (IBDSV(1,NBDSV).EQ.N .AND. IBDSV(2,NBDSV).LT.M) ) THEN
               NBDSV=NBDSV+1
               GO TO 20
            END IF
         END IF
      END IF
C  Print head
      IF(IHEDPR.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) CALL OCOUT('PRINT HEAD',
     1         ILBL,IFIL,N,M,0,IHDPR,IDUM)
      ELSE IF(IHEDPR.EQ.3) THEN
         IF(M.EQ.NSTP(N))
     1        CALL OCOUT('PRINT HEAD',ILBL,IFIL,N,M,0,IHDPR,IDUM)
      ELSE IF(IHEDPR.EQ.4) THEN
         CALL OCOUT('PRINT HEAD',ILBL,IFIL,N,M,0,IHDPR,IDUM)
      ELSE IF(IHEDPR.EQ.5) THEN
30       IF(NHDPR.LE.MXSCRN) THEN
            IF(IHDPR(1,NHDPR).EQ.N .AND. IHDPR(2,NHDPR).EQ.M) THEN
               CALL OCOUT('PRINT HEAD',ILBL,IFIL,N,M,NHDPR,IHDPR,IDUM)
               NHDPR=NHDPR+1
            ELSE IF(IHDPR(1,NHDPR).LE.0) THEN
               NHDPR=MXSCRN+1
            ELSE IF((IHDPR(1,NHDPR).LT.N) .OR.
     1         (IHDPR(1,NHDPR).EQ.N .AND. IHDPR(2,NHDPR).LT.M) ) THEN
               NHDPR=NHDPR+1
               GO TO 30
            END IF
         END IF
      END IF
C  Print drawdown
      IF(IDDNPR.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) CALL OCOUT('PRINT DRAWDOWN',
     1         ILBL,IFIL,N,M,0,IDDPR,IDDPRF)
      ELSE IF(IDDNPR.EQ.3) THEN
         IF(M.EQ.NSTP(N)) CALL OCOUT('PRINT DRAWDOWN',ILBL,IFIL,N,M,0,
     1         IDDPR,IDDPRF)
      ELSE IF(IDDNPR.EQ.4) THEN
         CALL OCOUT('PRINT DRAWDOWN',ILBL,IFIL,N,M,0,IDDPR,IDDPRF)
      ELSE IF(IDDNPR.EQ.5) THEN
40       IF(NDDPR.LE.MXSCRN) THEN
            IF(IDDPR(1,NDDPR).EQ.N .AND. IDDPR(2,NDDPR).EQ.M) THEN
               CALL OCOUT('PRINT DRAWDOWN',ILBL,IFIL,N,M,NDDPR,
     1             IDDPR,IDDPRF)
               NDDPR=NDDPR+1
            ELSE IF(IDDPR(1,NDDPR).LE.0) THEN
               NDDPR=MXSCRN+1
            ELSE IF((IDDPR(1,NDDPR).LT.N) .OR.
     1         (IDDPR(1,NDDPR).EQ.N .AND. IDDPR(2,NDDPR).LT.M) ) THEN
               NDDPR=NDDPR+1
               GO TO 40
            END IF
         END IF
      END IF
C  Save head
      IF(IHEDSV.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) CALL OCOUT('SAVE HEAD',
     1         ILBL,IFIL,N,M,0,IHDSV,IHDSVF)
      ELSE IF(IHEDSV.EQ.3) THEN
         IF(M.EQ.NSTP(N))
     1       CALL OCOUT('SAVE HEAD',ILBL,IFIL,N,M,0,IHDSV,IHDSVF)
      ELSE IF(IHEDSV.EQ.4) THEN
         CALL OCOUT('SAVE HEAD',ILBL,IFIL,N,M,0,IHDSV,IHDSVF)
      ELSE IF(IHEDSV.EQ.5) THEN
50       IF(NHDSV.LE.MXSCRN) THEN
            IF(IHDSV(1,NHDSV).EQ.N .AND. IHDSV(2,NHDSV).EQ.M) THEN
               CALL OCOUT('SAVE HEAD',ILBL,IFIL,N,M,NHDSV,IHDSV,IHDSVF)
               NHDSV=NHDSV+1
            ELSE IF(IHDSV(1,NHDSV).LE.0) THEN
               NHDSV=MXSCRN+1
            ELSE IF((IHDSV(1,NHDSV).LT.N) .OR.
     1         (IHDSV(1,NHDSV).EQ.N .AND. IHDSV(2,NHDSV).LT.M) ) THEN
               NHDSV=NHDSV+1
               GO TO 50
            END IF
         END IF
      END IF
C  Save drawdown
      IF(IDDNSV.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) CALL OCOUT('SAVE DRAWDOWN',
     1         ILBL,IFIL,N,M,0,IDDSV,IDDSVF)
      ELSE IF(IDDNSV.EQ.3) THEN
         IF(M.EQ.NSTP(N)) CALL OCOUT('SAVE DRAWDOWN',ILBL,IFIL,N,M,0,
     1         IDDSV,IDDSVF)
      ELSE IF(IDDNSV.EQ.4) THEN
         CALL OCOUT('SAVE DRAWDOWN',ILBL,IFIL,N,M,0,IDDSV,IDDSVF)
      ELSE IF(IDDNSV.EQ.5) THEN
60       IF(NDDSV.LE.MXSCRN) THEN
            IF(IDDSV(1,NDDSV).EQ.N .AND. IDDSV(2,NDDSV).EQ.M) THEN
               CALL OCOUT('SAVE DRAWDOWN',ILBL,IFIL,N,M,NDDSV,
     1                     IDDSV,IDDSVF)
               NDDSV=NDDSV+1
            ELSE IF(IDDSV(1,NDDSV).LE.0) THEN
               NDDSV=MXSCRN+1
            ELSE IF((IDDSV(1,NDDSV).LT.N) .OR.
     1         (IDDSV(1,NDDSV).EQ.N .AND. IDDSV(2,NDDSV).LT.M) ) THEN
               NDDSV=NDDSV+1
               GO TO 60
            END IF
         END IF
      END IF
C
99    CONTINUE
100   CONTINUE
C
C  Set in-use flags for output files.
500   IF(IDDSVF.NE.0 .OR. IDDPRF.NE.0) ISTRT=1
      IF(IHDSVF.NE.0) IFNUSE(IHEDUN)=IUNIT(12)
      IF(IDDSVF.NE.0) IFNUSE(IDDNUN)=IUNIT(12)
      IF(IBDSVF.NE.0) THEN
         IF(IBUDUN.GT.0) THEN
            IFNUSE(IBUDUN)=IUNIT(12)
         ELSE
            DO 520 I=1,40
            IF(IUNIT2(I).GT.0) IFNUSE(IUNIT2(I))=IUNIT(12)
520         CONTINUE
         END IF
      END IF
      CALL FNMRMV
C  Set IHEDUN, IDDNUN, and IBUDUN to 0 when there is no output -- the
C  files have been removed by FNMRMV
      IF(IHDSVF.EQ.0) IHEDUN=0
      IF(IDDSVF.EQ.0) IDDNUN=0
      IF(IBDSVF.EQ.0) IBUDUN=0
C  Set IUNIT2 to 0 if not used -- the files have been removed by FNMRMV
      IF(IBDSVF.EQ.0 .OR. IBUDUN.GT.0) THEN
         DO 600 I=1,40
         IUNIT2(I)=0
600      CONTINUE
      END IF
C
      RETURN
      END
      SUBROUTINE OCOUT(CVAR,ILBL,IFIL,KPER,KSTP,ILIST,IFLG,ISV)
C     ******************************************************************
C     Write a line of output control information for a specific time
C     step
C     ******************************************************************
      INCLUDE 'mfi.gbl'
      DIMENSION IFLG(17,MXSCRN)
      CHARACTER*(*) CVAR
C
      ISV=ISV+1
      IF(ILBL.EQ.0) WRITE(IFIL,'(A,I4,A,I4)') 'PERIOD',KPER,' STEP',KSTP
      ILBL=1
C
      IF(ILIST.EQ.0) THEN
         WRITE(IFIL,'(4X,A)') CVAR
      ELSE IF(IFLG(3,ILIST).LE.0) THEN
         WRITE(IFIL,'(4X,A)') CVAR
      ELSE
         DO 10 I=1,15
         IF(IFLG(I+2,ILIST).LE.0) GO TO 20
10       CONTINUE
         I=16
20       I=I-1
         WRITE(IFIL,'(4X,A,1X,15I4)')
     1              CVAR,(IFLG(J+2,ILIST),J=1,I)
      END IF
C
      RETURN
      END
      SUBROUTINE OCSVOR(IFIL,IBDSVF,IHDSVF,IDDSVF,IDDPRF)
C     ******************************************************************
C     SAVE DATA FOR OUTPUT CONTROL FOR ORIGINAL MODEL
C     ******************************************************************
C
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      INCLUDE 'mfi.gbl'
      COMMON /BASCOM/NSTP(MXPER),PERLEN(MXPER),TSMULT(MXPER)
C  Common block for Output Control
      COMMON /OCCOM/IBDOPT,LBHDSV,LBDDSV,
     1     IHEDFM,IDDNFM,IHEDPR,IDDNPR,IHEDSV,IDDNSV,IBUDPR,IBUDSV,
     2     IHDPR(17,MXSCRN),IDDPR(17,MXSCRN),IHDSV(17,MXSCRN),
     3     IDDSV(17,MXSCRN),IBDPR(17,MXSCRN),IBDSV(17,MXSCRN)
C     ------------------------------------------------------------------
C
C  RECORD TYPE 1
      IHU=0
      IF(IHEDUN.GT.0) IHU=IUREAL(IHEDUN)
      IDU=0
      IF(IDDNUN.GT.0) IDU=IUREAL(IDDNUN)
      WRITE(IFIL,'(4I10,A)') IHEDFM,IDDNFM,IHU,IDU,
     1                    '  IHEDFM,IDDNFM,IHEDUN,IDDNUN'
C
      NBDPR=1
      NBDSV=1
      NHDPR=1
      NDDPR=1
      NHDSV=1
      NDDSV=1
C  Loop through all time steps specifying when output is desired
      DO 100 N=1,NPER
      DO 99 M=1,NSTP(N)
C
C  Print overall budget
      IBUDFL=0
      IF(IBUDPR.EQ.3) THEN
         IF(M.EQ.NSTP(N)) IBUDFL=1
      ELSE IF(IBUDPR.EQ.4) THEN
         IBUDFL=1
      ELSE IF(IBUDPR.EQ.5) THEN
10       IF(NBDPR.LE.MXSCRN) THEN
            IF(IBDPR(1,NBDPR).EQ.N .AND. IBDPR(2,NBDPR).EQ.M) THEN
               IBUDFL=1
               NBDPR=NBDPR+1
            ELSE IF(IBDPR(1,NBDPR).LE.0) THEN
               NBDPR=MXSCRN+1
            ELSE IF((IBDPR(1,NBDPR).LT.N) .OR.
     1         (IBDPR(1,NBDPR).EQ.N .AND. IBDPR(2,NBDPR).LT.M) ) THEN
               NBDPR=NBDPR+1
               GO TO 10
            END IF
         END IF
      END IF
C
C  Save CBC budget
      ICBCFL=0
      IF(IBUDSV.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) ICBCFL=1
      ELSE IF(IBUDSV.EQ.3) THEN
         IF(M.EQ.NSTP(N)) ICBCFL=1
      ELSE IF(IBUDSV.EQ.4) THEN
         ICBCFL=1
      ELSE IF(IBUDSV.EQ.5) THEN
20       IF(NBDSV.LE.MXSCRN) THEN
            IF(IBDSV(1,NBDSV).EQ.N .AND. IBDSV(2,NBDSV).EQ.M) THEN
               ICBCFL=1
               NBDSV=NBDSV+1
            ELSE IF(IBDSV(1,NBDSV).LE.0) THEN
               NBDSV=MXSCRN+1
            ELSE IF((IBDSV(1,NBDSV).LT.N) .OR.
     1         (IBDSV(1,NBDSV).EQ.N .AND. IBDSV(2,NBDSV).LT.M) ) THEN
               NBDSV=NBDSV+1
               GO TO 20
            END IF
         END IF
      END IF
C
C  RECORD TYPE 2
      WRITE(IFIL,'(A,2I10,A,I4,A,I4)') '         1         1',
     1  IBUDFL,ICBCFL,'  1,1,IBUDFL,ICBCFL: PER.',N,'  STEP',M
      IBDSVF=IBDSVF+ICBCFL
C
      DO 98 K=1,NLAY 
C
C  Print head
      IHP=0
      IF(IHEDPR.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) IHP=1
      ELSE IF(IHEDPR.EQ.3) THEN
         IF(M.EQ.NSTP(N)) IHP=1
      ELSE IF(IHEDPR.EQ.4) THEN
         IHP=1
      ELSE IF(IHEDPR.EQ.5) THEN
30       IF(NHDPR.LE.MXSCRN) THEN
            IF(IHDPR(1,NHDPR).EQ.N .AND. IHDPR(2,NHDPR).EQ.M) THEN
               IF(IHDPR(3,NHDPR).EQ.0) THEN
                  IHP=1
               ELSE
                  DO 31 KK=3,17
                  IF(IHDPR(KK,NHDPR).EQ.0) GO TO 32
                  IF(IHDPR(KK,NHDPR).EQ.K) IHP=1
31                CONTINUE
               END IF
32             IF(K.EQ.NLAY) NHDPR=NHDPR+1
            ELSE IF(IHDPR(1,NHDPR).LE.0) THEN
               NHDPR=MXSCRN+1
            ELSE IF((IHDPR(1,NHDPR).LT.N) .OR.
     1         (IHDPR(1,NHDPR).EQ.N .AND. IHDPR(2,NHDPR).LT.M) ) THEN
               NHDPR=NHDPR+1
               GO TO 30
            END IF
         END IF
      END IF
C  Print drawdown
      IDP=0
      IF(IDDNPR.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) IDP=1
      ELSE IF(IDDNPR.EQ.3) THEN
         IF(M.EQ.NSTP(N)) IDP=1
      ELSE IF(IDDNPR.EQ.4) THEN
         IDP=1
      ELSE IF(IDDNPR.EQ.5) THEN
40       IF(NDDPR.LE.MXSCRN) THEN
            IF(IDDPR(1,NDDPR).EQ.N .AND. IDDPR(2,NDDPR).EQ.M) THEN
               IF(IDDPR(3,NDDPR).EQ.0) THEN
                  IDP=1
               ELSE
                  DO 41 KK=3,17
                  IF(IDDPR(KK,NDDPR).EQ.0) GO TO 42
                  IF(IDDPR(KK,NDDPR).EQ.K) IDP=1
41                CONTINUE
               END IF
42             IF(K.EQ.NLAY) NDDPR=NDDPR+1
            ELSE IF(IDDPR(1,NDDPR).LE.0) THEN
               NDDPR=MXSCRN+1
            ELSE IF((IDDPR(1,NDDPR).LT.N) .OR.
     1         (IDDPR(1,NDDPR).EQ.N .AND. IDDPR(2,NDDPR).LT.M) ) THEN
               NDDPR=NDDPR+1
               GO TO 40
            END IF
         END IF
      END IF
C  Save head
      IHS=0
      IF(IHEDSV.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) IHS=1
      ELSE IF(IHEDSV.EQ.3) THEN
         IF(M.EQ.NSTP(N)) IHS=1
      ELSE IF(IHEDSV.EQ.4) THEN
         IHS=1
      ELSE IF(IHEDSV.EQ.5) THEN
50       IF(NHDSV.LE.MXSCRN) THEN
            IF(IHDSV(1,NHDSV).EQ.N .AND. IHDSV(2,NHDSV).EQ.M) THEN
               IF(IHDSV(3,NHDSV).EQ.0) THEN
                  IHS=1
               ELSE
                  DO 51 KK=3,17
                  IF(IHDSV(KK,NHDSV).EQ.0) GO TO 52
                  IF(IHDSV(KK,NHDSV).EQ.K) IHS=1
51                CONTINUE
               END IF
52             IF(K.EQ.NLAY) NHDSV=NHDSV+1
            ELSE IF(IHDSV(1,NHDSV).LE.0) THEN
               NHDSV=MXSCRN+1
            ELSE IF((IHDSV(1,NHDSV).LT.N) .OR.
     1         (IHDSV(1,NHDSV).EQ.N .AND. IHDSV(2,NHDSV).LT.M) ) THEN
               NHDSV=NHDSV+1
               GO TO 50
            END IF
         END IF
      END IF
C  Save drawdown
      IDS=0
      IF(IDDNSV.EQ.2) THEN
         IF(M.EQ.NSTP(N) .AND. N.EQ.NPER) IDS=1
      ELSE IF(IDDNSV.EQ.3) THEN
         IF(M.EQ.NSTP(N)) IDS=1
      ELSE IF(IDDNSV.EQ.4) THEN
         IDS=1
      ELSE IF(IDDNSV.EQ.5) THEN
60       IF(NDDSV.LE.MXSCRN) THEN
            IF(IDDSV(1,NDDSV).EQ.N .AND. IDDSV(2,NDDSV).EQ.M) THEN
               IF(IDDSV(3,NDDSV).EQ.0) THEN
                  IDS=1
               ELSE
                  DO 61 KK=3,17
                  IF(IDDSV(KK,NDDSV).EQ.0) GO TO 62
                  IF(IDDSV(KK,NDDSV).EQ.K) IDS=1
61                CONTINUE
               END IF
62             IF(K.EQ.NLAY) NDDSV=NDDSV+1
            ELSE IF(IDDSV(1,NDDSV).LE.0) THEN
               NDDSV=MXSCRN+1
            ELSE IF((IDDSV(1,NDDSV).LT.N) .OR.
     1         (IDDSV(1,NDDSV).EQ.N .AND. IDDSV(2,NDDSV).LT.M) ) THEN
               NDDSV=NDDSV+1
               GO TO 60
            END IF
         END IF
      END IF
C
C
C  RECORD 3
      WRITE(IFIL,'(4I10,A)') IHP,IDP,IHS,IDS,
     1     '  Hdpr,Ddpr,Hdsv,Ddsv'
      IHDSVF=IHDSVF+IHS
      IDDSVF=IDDSVF+IDS
      IDDPRF=IDDPRF+IDP
98    CONTINUE
C
99    CONTINUE
100   CONTINUE
C
      RETURN
      END
